> For the complete documentation index, see [llms.txt](https://docs.cspr.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cspr.cloud/rest-api/fungible-token-rate.md).

# Fungible token rate

`FTRate` entity represents rates for fungible tokens traded on the Casper Network tracked in various [currencies](/rest-api/currency.md) .

### Properties

The `FTRate` entity has the following properties:

| Property                      | Type      | Description                                                                            |
| ----------------------------- | --------- | -------------------------------------------------------------------------------------- |
| `token_contract_package_hash` | `string`  | Fungible token contract package hash                                                   |
| `currency_id`                 | `uint16`  | [Currency](/rest-api/currency.md) identifier                                           |
| `amount`                      | `float64` | Rate amount in the specified currency                                                  |
| `volume`                      | `string`  | The swap volume the rate was calculated on                                             |
| `dex_id`                      | `uint16`  | [DEX](/rest-api/dex.md) identifier                                                     |
| `transaction_hash`            | `string`  | [Deploy](/rest-api/deploy.md) hash associated with this rate                           |
| `timestamp`                   | `string`  | Transaction timestamp in the [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format |

**Example**

```json
{
  "amount": "0.25",
  "volume": "1234.567",
  "transaction_hash": "a1b2c3d4e5f6g7h8i9j0k1l2m3n4o5p6q7r8s9t0u1v2w3x4y5z6",
  "token_contract_package_hash": "b1c2d3e4f5g6h7i8j9k0l1m2n3o4p5q6r7s8t9u0v1w2x3y4z5a6",
  "dex_id": 2,
  "currency_id": 1,
  "timestamp": "2024-01-05T12:51:00Z"
}
```

### Optional properties

None

### Relations

The `FTRate` entity has the following relations with other entities:

| Entity                                             | Mapping property              | Description                                                          |
| -------------------------------------------------- | ----------------------------- | -------------------------------------------------------------------- |
| [`ContractPackage`](/rest-api/contract-package.md) | `token_contract_package_hash` | Rates are tracked for fungible token contracts                       |
| [`Currency`](/rest-api/currency.md)                | `currency_id`                 | Rates are calculated for different currencies                        |
| [`Deploy`](/rest-api/deploy.md)                    | `transaction_hash`            | Rates are calculated based on transactions (deploys) on Casper DEXes |
| [`DEX`](/rest-api/dex.md)                          | `dex_id`                      | Rates are calculated separately for different Casper DEXes           |

## Endpoints

The fungible token fiat rate endpoints are:

* [Get the latest fungible token contract rate](/rest-api/fungible-token-rate/get-latest-token-contract-rate.md)
* [Get historical fungible token contract rates](/rest-api/fungible-token-rate/get-token-contract-rates.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/rest-api/fungible-token-rate.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
